import sys
import gobject, dbus
import ctypes
import gtk
import osso
from dbus.mainloop.glib import DBusGMainLoop
import sqlite3
import re
import time
import glib

phone_number = ""
contactname = ""

#############################################
#    Update conversations app UI
#############################################

def UpdateUI(eventid):
    rtcom_el_lib.rtcom_el_fire_event_updated(rtcom_el_obj, int(eventid))

#############################################
#    Parse SMS
#############################################
    
def FindPhoneNumbers(smstext):
    found = re.finditer('[+]{0,1}[0-9]{10,}', smstext)
    return found
        
#############################################
#    Handle Glist structures
#############################################

glib = ctypes.CDLL('libglib-2.0.so.0')
def glist(addr):
    class _GList(ctypes.Structure):
        _fields_ = [('data', ctypes.c_void_p),
                    ('next', ctypes.c_void_p)]
    l = addr
    while l:
        l = _GList.from_address(l)
        yield l.data
        l = l.next

#############################################
#    Search contacts
#############################################

def aggregator_ready_cb(aggregator, error, user_data):
    global phone_number
    global contactname	
    contacts = osso_abook.osso_abook_aggregator_find_contacts_for_phone_number(aggregator, phone_number, 1)
    if contacts:
        for i in glist(contacts):
            contact_get_display_name = osso_abook.osso_abook_contact_get_display_name
            contact_get_display_name.restype = ctypes.c_char_p
            contactname = str(contact_get_display_name(i))
        glib.g_list_free(contacts)
    else:
        print "No contacts found with phone number %s." % phone_number

#############################################
#    DBus handler for incoming SMS
#############################################

def OnNewSMS(id, local_uid, remote_uid, remote_ebook_uid, group_uid, service):
	global phone_number
	global contactname
        
        if service != "RTCOM_EL_SERVICE_SMS" and service != "RTCOM_EL_SERVICE_CHAT":
            return

        if (remote_uid != 'Maxis') and (remote_uid != 'Voicemail'):
            return
              
        cur = conn.cursor()
        # select free_text (message body)
        cur.execute("select free_text from events where outgoing = 0 and id = ?", (id,))
        data = cur.fetchone()

        if data != None:
            smstext = data[0]
	    if len(smstext) > 0:
		numbers = FindPhoneNumbers(smstext)
		oldinsertpos = 0
		newtext = ''
		for item in numbers:
		    print item.start(), item.group(), item.end()
		    phone_number = str(item.group())
		    osso_abook.osso_abook_waitable_call_when_ready(aggregator, cb_proto, 0, 0)
		    newtext = smstext[oldinsertpos:item.end()] + " (" + contactname + ") "
		    oldinsertpos = oldinsertpos + item.end() + 1
		if oldinsertpos > 0:
		    if oldinsertpos < len(smstext):
		        newtext = newtext + smstext[oldinsertpos:len(smstext)]
                    print newtext
                if len(newtext) > 0:
                    cur.execute("update events set free_text = ? where id = ?", (newtext, id,))
                    UpdateUI(id)
        cur.close()
		        
#############################################
#    Main - Execution starts here
#############################################

osso_ctx = osso.Context("test_abook", "0.1")
osso_abook = ctypes.CDLL('libosso-abook-1.0.so.0')
argv_type = ctypes.c_char_p * len(sys.argv)
argv = argv_type(*sys.argv)
argc = ctypes.c_int(len(sys.argv))
osso_abook.osso_abook_init(ctypes.byref(argc), ctypes.byref(argv), hash(osso_ctx))

aggregator = osso_abook.osso_abook_aggregator_get_default(0)
wait_cb_type = ctypes.CFUNCTYPE(None, ctypes.c_void_p, ctypes.c_void_p, ctypes.c_void_p)
# Keep prototype object reference so it is not destroyed
cb_proto = wait_cb_type(aggregator_ready_cb)

rtcom_el_lib = ctypes.CDLL("librtcom-eventlogger.so.1")
rtcom_el_obj = rtcom_el_lib.rtcom_el_new()

DBusGMainLoop(set_as_default=True)
bus = dbus.SessionBus()
bus.add_signal_receiver(OnNewSMS, dbus_interface="rtcomeventlogger.signal", signal_name="NewEvent")
conn = sqlite3.connect('/home/user/.rtcom-eventlogger/el-v1.db', isolation_level=None)
gobject.MainLoop().run()
